class Buffer(object):
	BUFFER_SIZE = 65536

	def __init__(self, fh):
		self.__fh = fh
		self.__window = ""
		self.__offset = 0
		self.__upper = 0

	def popFront(self, size):
		#print "@ " + str(self.__offset)
		#print "popFront(" + str(size) + ")",

		if size > len(self.__window):
			self.__readUntil(self.__offset + size)
		ret = self.__window[:size]
		self.__window = self.__window[size:]
		self.__offset += size

		#print " -> len(" + str(len(ret)) + ")"

		return ret

	def __getitem__(self, i):
		#print "[" + str(i) + "]",

		if i >= self.__upper:
			self.__readUntil(i)

		#print " -> " + repr(self.__window[i - self.__offset])
		return self.__window[i - self.__offset]

	def __readUntil(self, pos):
		if not self.__fh:
			return

		needRead = pos - self.__offset - len(self.__window) + 1
		needRead = ((needRead + self.BUFFER_SIZE - 1) / self.BUFFER_SIZE) * self.BUFFER_SIZE

		read_ = self.__fh.read(needRead)

		if len(read_) == 0:
			self.__fh.close()
			self.__fh = None

		self.__window += read_
		self.__upper += len(read_)
