import unittest
import StringIO

import ReadLineAdapter

class ReadLineAdapterTestCase(unittest.TestCase):
    def test1(self):
        s = "\nfoobar\n\n"
        rla = ReadLineAdapter.ReadLineAdapter(StringIO.StringIO(s))

        self.assertEquals(rla.readline(), "\n")
        self.assertEquals(rla.readline(), "foobar\n")
        self.assertEquals(rla.readline(), "\n")
        self.assertEquals(rla.readline(), "")
        self.assertEquals(rla.readline(), "")

    def test2(self):
        rla = ReadLineAdapter.ReadLineAdapter(StringIO.StringIO(""))
        self.assertEquals(rla.readline(), "")

    def test3(self):
        rla = ReadLineAdapter.ReadLineAdapter(StringIO.StringIO("\n"))
        self.assertEquals(rla.readline(), "\n")
        self.assertEquals(rla.readline(), "")

    def test4(self):
        s = (65536 * " ") + "\n"
        rla = ReadLineAdapter.ReadLineAdapter(StringIO.StringIO(s))
        self.assertEquals(rla.readline(), s)
        #self.assertEquals(rla.readline(), "")

if __name__ == '__main__':
    unittest.main()
